% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotting.R
\name{heatmapTransitionProbs}
\alias{heatmapTransitionProbs}
\title{Heatmap of transition probabilities}
\usage{
heatmapTransitionProbs(model)
}
\arguments{
\item{model}{A \code{\link{multiHMM}} object or file that contains such an object.}
}
\value{
A \code{\link[ggplot2]{ggplot}} object.
}
\description{
Plot a heatmap of transition probabilities for a \code{\link{multiHMM}} model.
}
\examples{
## Get an example multiHMM ##
file <- system.file("data","multivariate_mode-combinatorial_condition-SHR.RData",
                    package="chromstaR")
model <- get(load(file))
## Plot transition probabilites as heatmap
heatmapTransitionProbs(model)

}
\seealso{
\code{\link{plotting}}
}

